//
//  DBManager.m
//  
//
//  Created by test on 10/27/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//
#import "DBManager.h"
@interface DBManager ()
- (NSString*) getDBPath;
- (void)createDatabaseIfNeeded;
@end
@implementation DBManager
+ (DBManager*)sharedInstance
{
    static DBManager *instace = nil;
    static dispatch_once_t oncePredicate;
    dispatch_once(&oncePredicate, ^{
        instace = [[self alloc] init];
        
    });
    return instace;
}
- (BOOL)openDataBase:(NSString*)dataBase{
    self.dbName = dataBase;
    NSString *dbPath = [self getDBPath];
    [self createDatabaseIfNeeded];
    NSLog(@"dbPath= %@ \n",dbPath);
    self.db = [FMDatabase databaseWithPath:dbPath];
    self.queue = [FMDatabaseQueue databaseQueueWithPath:dbPath];
    if(self.queue==0x00){
        NSLog(@"error opening the database with queue!");
        return NO;
    }
    else{
        [self.queue inDatabase:^(FMDatabase *db){
            [db setShouldCacheStatements:YES];
        }];
    }
    if(![_db open]){
        NSLog(@"error opening the database!");
        return NO;
    }
    return YES;
}
- (void)closeDataBase{
    [_db close];
}
-(void)createDatabaseIfNeeded{
    NSFileManager *fileManager = [NSFileManager defaultManager];
    NSError *error;
    NSString *dbPath = [self getDBPath];
    BOOL success = [fileManager fileExistsAtPath:dbPath];
	NSLog(@"\n createEditableCopyOfDatabaseIfNeeded database %@ \n",self.dbName);
    if (success)
	{
        //[fileManager removeFileAtPath:writableDBPath error:&error];
		return;
	}
    NSString *defaultDBPath = [[[NSBundle mainBundle] resourcePath] stringByAppendingPathComponent:self.dbName];
    success = [fileManager copyItemAtPath:defaultDBPath toPath:dbPath error:&error];
    if (!success) {
        NSAssert1(0, @"Failed to create writable database file with message '%@'.", [error localizedDescription]);
    }
	else {
		NSLog(@"\n create database success");
	}
}
- (NSString*) getDBPath{
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDirectory = [paths objectAtIndex:0];
    NSString *path = [documentsDirectory stringByAppendingPathComponent:self.dbName];
    return path;	
}
@end
